//	ATtiny2313
//	Videoo ubN	AiORp[^pA/DRo[^
//	
//	ATtiny2313̓q[Yrbg20MHz
//	ubh{[hɂăeXg
//	WinAVR-20080610	œKIvVu-O2v
//	
//	2008/12/04	v1.00	

/*	|[gΉ	[ATtiny2313]
	bit		7	6	5	4	3	2	1	0
	PORTB	-	-	-	swR	swL	Chg	A1	A0		PB4-3:XCb`	PB2:RfT[d^d	PB1-0:AiO
	PORTD	x	-	-	-	V2	V1	-	-		Video1-2
	
	[Video Output](H=5v, L=0v)
	Video1(1.2k)	H		L		H		L
	Video2(470)	H		H		L		L
	Output			0.91v	0.69v	0.29v	0v
					White	Gray	Black	Sync
	
	Video1>--R[1.2k]--+
	Video2>--R[ 470]--+--<Output
	                  |
	                  R[75]
	                  |
	                 ///
*/

/*
yVѕz
XCb`ŃvC	cXCb`܂͉EŃvCJnB
{[ŃvC	co[[܂͉E[܂ňړŃvCJnB
ubNSNAB1bɎ̃vCҋ@ԂɂȂB
e𗎂ƂQ[I[o[B1bɎ̃vCҋ@ԂɂȂB

yẽoG[Vz
ʏvC̒eŎ΂߂45x݂̂AoG[V^̒eł͌X2̑łԂłB
Eǂ炩̃XCb`ȂdƃoG[V^̃vCłB
ʏvCɖ߂ɂ͓d꒼iXCb`ɓdjB
*/

#define	F_CPU	20000000UL	//20MHz

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/sleep.h>
#include	<util/delay.h>


#define	ColorWHITE	0b00001100
#define	ColorGRAY	0b00001000
#define	ColorBLACK	0b00000100
#define	SIGNAL_SYNC	0b00000000

#define	SCRN_COLOR	ColorBLACK		//ʔwiF
#define	BAR_COLOR	ColorGRAY		//o[̐F
#define	BALL_COLOR	ColorWHITE		//{[̐F
//{[̐FizɃZbglƂāj
#define	BALL_COLOR_NUM	2		//0:ColorBLACK, 1:ColorGRAY, 2:ColorWHITE

//`Ɋւ鑖̐ݒ
#define	DRAW_LINE_TOP	(21 + 2)	//\JnCijB21ȏł邱Ɓi+n͉ʐ؂ɑΏ钲lj
#define	CELL_H			10			//P}X̍CƂ邩
//vCtB[h̍L	オ(0,0)
#define	FIELD_W			16		//16}XiςƍœKɂĕ`悪K^j
#define	FIELD_H			24		//c24}X
//ubNAo[A{[̈ʒuA傫ivCtB[h̃}ẌʒuŎw肷BPʂł͂Ȃj
#define	BLOCK_COLUMN	FIELD_W
#define	BLOCK_ROW		4		//obt@TCY (BLOCK_COLUMN * BLOCK_ROW)byte ƂȂ
#define	BLOCK_AREA_Y	3		//0ȏł邱
#define	BLOCK_AREA_H	BLOCK_ROW
#define	BAR_Y			((FIELD_H - 1) - 1)		//o[̉ɂPšԂ󂯂iڂ̍D݂Łj
#define	BAR_W			5
//{[Ao[̈ړ
#define	DIREC_UP		-1		//W
#define	DIREC_DOWN		1		//W
#define	DIREC_LEFT		-1		//W
#define	DIREC_RIGHT		1		//W
#define	DIREC_NEUTRAL	0		//WωȂî݊֌Wj
#define	MOVE_WAIT		(262 * 3)	//ړ҂iPtB[h̑̔{Ŏw肷jFQ[̃Xs[h

//AiÓil̐ݒ̓Lu[V˂j
//vOŕKvȂ̂ACADC_STEP,ACADC_MAX,ACADC_MIN.	̑͂̏̌vZŎg̒l
#define	ACADC_MAX_PRE	0b01000000		//fobO\Ă̒l
#define	ACADC_MIN_PRE	0b00001000		//fobO\Ă̒l
#define	ACADC_STEP		((ACADC_MAX_PRE - ACADC_MIN_PRE) / (FIELD_W - BAR_W))	//1}Xړ̍ݕ
#define	ACADC_DIFF		(((ACADC_MAX_PRE - ACADC_MIN_PRE) - ACADC_STEP * (FIELD_W - BAR_W)) / 2)	//u͔͈̓́vƁuݕtZz͔͈̓́v̍̔
#define	ACADC_MAX		(ACADC_MAX_PRE - ACADC_DIFF)	//u̔vőlƍŏlɐU蕪AvOł͂̕␳lg
#define	ACADC_MIN		(ACADC_MIN_PRE + ACADC_DIFF)	//u̔vőlƍŏlɐU蕪AvOł͂̕␳lg

//AiO͕\̃fobOtO
#define	_ADC_DEBUG	0	//0:{	1:fobO\


enum	_ST		//Q[̏
{
	ST_READY,
	ST_PLAY,
	ST_CLEAR,
	ST_GAMEOVER
};

enum	_ADCST	//AiORp[^pA/DRo[^̏
{
	ADCST_CHARGING,
	ADCST_CHARGESTOP,
	ADCST_DISCHGWAIT
};


//}N`
#define delay_loop		_delay_loop_1		//delay_basic.hŒ`ꂽ֐𒼐ڎw肷
#define nop()			asm volatile("nop"::)
#define videoOut(c)		{ PORTD = c; }
#define cellToLine(c)	(DRAW_LINE_TOP + (c) * CELL_H)	//vCtB[h̃}Xڂ𑖍ɕϊ


//O[oϐ
uint8_t		block[BLOCK_ROW][BLOCK_COLUMN];		//ubN̔z	FɑΉl0,1,2
uint8_t		bbPos[BLOCK_COLUMN] = {0};			//{[Ao[̈ʒui[zi֐̈Ƃėpj
register	volatile	int8_t		barX	asm("r2");		//o[̈ʒui}XڂŎwj
register	volatile	int8_t		ballX	asm("r3");		//{[̈ʒui}XڂŎwj
register	volatile	int8_t		ballY	asm("r4");		//{[̈ʒui}XڂŎwj
register	volatile	uint16_t	lineCount	asm("r6");	//̃JE^(16bitȂ̂r+1܂łgp)
register	volatile	uint8_t		fieldCount	asm("r5");	//PtB[hiPʕ`j̃JE^


//vg^Cv錾
void	draw();
void	aryPaint(uint16_t *aryptr, uint8_t size);
void	init(int8_t *barDirecX, int8_t *ballDirecX, int8_t *ballDirecY, uint8_t *restCount);
uint8_t	acadc(uint8_t val);
uint8_t	getAnalogBarX(uint8_t adcVal);


//8bit^C}^JE^荞
ISR(TIMER0_COMPA_vect)
{
	if (++lineCount == 263)		//^tB[h̋ʂ͂ȂAPtB[ȟJԂŉʂ
	{
		lineCount = 1;
		fieldCount++;
	}
	
	if (lineCount < 4)			//1-3C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(2.3);			//2.3us
		videoOut(ColorBLACK);
	}
	else if (lineCount < 7)		//4-6C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(58.86);		//63.56-4.7=58.86us
		videoOut(ColorBLACK);
	}
	else if (lineCount < 10)	//7-9C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(2.3);			//2.3us
		videoOut(ColorBLACK);
	}
	else	//10Cȍ~iʂŌ̂21Cȍ~j
	{
		//uLO
		videoOut(ColorBLACK);
		_delay_us(1.5);			//1.5us
		videoOut(SIGNAL_SYNC);
		_delay_us(4.7);			//4.7us
		videoOut(ColorBLACK);
		_delay_us(4.7);			//4.7us
		
		//c63.56-(1.5+4.7+4.7)=53.47usʂŌ1C͈̔
		//̊荞ݔ܂łɕ`揈{f[^邱
	}
	
	draw();
}

int	main(void)
{
	int8_t		ballDirecX, ballDirecY, barDirecX;	//{[Ao[̕
	uint16_t	moveWait;		//`^C~O҂
	uint8_t		sw;				//XCb`
	uint8_t		restCount;		//cubNiPubNQJEgj
	uint8_t		state;			//is
	uint8_t		ballPainted;	//ubN̈Ƀ{[`Ƃ̃tOiƂ̔ɕKvj
	uint8_t		adcVal;			//{[̈ʒuA/DRo[gl
	uint8_t		prevBarX;		//Õo[̈ʒuiAiORg[ŕKvj
	uint8_t		analogMode;		//샂[h	1:{[ő	0:XCb`ő
	uint8_t		isVariety, ballXCount, ballXStep;	//ẽoG[V
	
	//|[gݒ
	DDRD	= 0b00001100;	//VideoMI/Os2
	DDRB	= 0b00000100;	//PB2:RfT[d^d
	PORTB	= 0b00011000;	//XCb`2
	
	//8bit^C}ݒ
	TCCR0A	= 0b00000010;	//bit1-0:CTC
	TCCR0B	= 0b00000010;	//bit3  :CTC//JEg 20MHz8 = 0.4usԊu
	OCR0A	= 159;			//荞ݎ 63.56us / 0.4us = 158.9JEg
	//16bit^C}ݒ
	TCCR1A	= 0b00000000;	//bit1-0:W
	TCCR1B	= 0b00000001;	//bit4-3:W//JEg 20MHz̕Ȃ = 0.05usԊu
	//
	TIMSK	= 0b00000001;	//16bit:荞݂Ȃ	8bit:rv荞
	
	//AiORp[^̐ݒ
	ACSR	= 0b00000000;
	
	lineCount = 0;
	fieldCount = 0;
	moveWait = MOVE_WAIT;
	state = ST_READY;
	ballPainted = 0;
	adcVal = (ACADC_MAX + ACADC_MIN) / 2;
	prevBarX = 0;
	analogMode = 0;
	
	//ẽoG[V߂
	sw = PINB;
	isVariety = (~sw & 0b00011000) ? 1 : 0;		//ǂ炩̃{^Ăꍇ
	
	//vCJn̏
	init(&barDirecX, &ballDirecX, &ballDirecY, &restCount);
	ballXCount = 0;	ballXStep = 1;	//ẽoG[V
	
	set_sleep_mode(SLEEP_MODE_IDLE);	//X[v[hw
	sei();		//荞݋
	
	while (1)
	{
		//X[v[h˓i荞ݔŕAj
		sleep_mode();
		//ȉAȀ
		
		//A/DRo[^𓮍삳iAvs͏펞j
		adcVal = acadc(adcVal);
		
		//{[Ao[̈ړ^C~O҂
		if (0 < --moveWait) continue;	//while(1)
		moveWait = MOVE_WAIT;
		
#if	_ADC_DEBUG
		barX = getAnalogBarX(adcVal);
		continue;
#endif
		
		if (state != ST_PLAY)	//܂vCۂŕivCif点j
		{
			if (state == ST_READY)
			{
				//XCb`mF
				sw = PINB;
				if (~sw & 0b00011000)	//ǂ炩̃{^
				{
					analogMode = 0;
					state = ST_PLAY;
				}
				//{[mF
				barX = prevBarX = getAnalogBarX(adcVal);
				if (barX == 0 || barX == FIELD_W - BAR_W)	//{[E[܂ŉ񂵂
				{
					analogMode = 1;
					state = ST_PLAY;
				}
			}
			else	//ST_CLEAR, ST_GAMEOVER
			{
				if (0x30 < fieldCount)		//KȎԑ҂
				{
					init(&barDirecX, &ballDirecX, &ballDirecY, &restCount);
					ballXCount = 0;	ballXStep = 1;	//ẽoG[V
					state = ST_READY;
				}
			}
			continue;	//while(1)
		}
		//ȉ(state == ST_PLAY)
		
		//o[ړ
		if (analogMode)		//{[ő
		{
			//A/DRo[^̕ϊlo[̈ʒu߂
			barX = getAnalogBarX(adcVal);
			if (prevBarX < barX) barDirecX = DIREC_RIGHT;
			else if (barX < prevBarX) barDirecX = DIREC_LEFT;
			else barDirecX = DIREC_NEUTRAL;
			prevBarX = barX;
		}
		else	//XCb`ő
		{
			//L[͔iςȂLj
			barDirecX = DIREC_NEUTRAL;
			sw = PINB;
			if ((~sw & 0b00001000) && 0 < barX)		//XCb`uv
			{
				barX--;
				barDirecX = DIREC_LEFT;
			}
			if ((~sw & 0b00010000) && barX < FIELD_W - BAR_W)	//XCb`uEv
			{
				barX++;
				barDirecX = DIREC_RIGHT;
			}
		}
		
		//OAubN̈Ƀ{[
		if (BLOCK_AREA_Y <= ballY && ballY < BLOCK_AREA_Y + BLOCK_AREA_H)
		{
			if (ballPainted)	//̔肪ȂƗLȃubNĂ܂ƂN
			{
				uint8_t		rr = ballY - BLOCK_AREA_Y;
				block[rr][ballX] = 0;
				ballPainted = 0;
			}
		}
		
		//{[ړF
		if (ballX == 0)		//vCtB[h̍[Ŕ
		{
			ballDirecX = DIREC_RIGHT;
		}
		else if (ballX == FIELD_W - 1)		//vCtB[h̉E[Ŕ
		{
			ballDirecX = DIREC_LEFT;
		}
//		ballX += ballDirecX;			//ʏړ̏ꍇ
		if (++ballXCount == ballXStep)	//ẽoG[Vlړ
		{
			ballX += ballDirecX;
			ballXCount = 0;
		}
		
		//{[ړFc
		if (ballY == 0)		//vCtB[h̏[Ŕ
		{
			ballDirecY = DIREC_DOWN;
		}
		else if (ballY == BAR_Y - 1)	//o[Ƃ̓蔻
		{
			if (barX <= ballX && ballX < barX + BAR_W)	//o[ɓꍇ
			{
				ballDirecY = DIREC_UP;	//
				
				//{[̉̐ύX
				//bar_ball	||||
				//----------+--+--+--+
				//		|<<|||
				//|		||||
				//		|||>>|
/*ʏړ̏ꍇ
				if (ballDirecX == DIREC_LEFT)
				{
					if (barDirecX == DIREC_LEFT && 0 < ballX) ballX--;	//o[łP}X点
					else if (barDirecX == DIREC_RIGHT) ballDirecX = DIREC_NEUTRAL;
				}
				else if (ballDirecX == DIREC_RIGHT)
				{
					if (barDirecX == DIREC_RIGHT && ballX < FIELD_W - 1) ballX++;	//o[łP}X点
					else if (barDirecX == DIREC_LEFT) ballDirecX = DIREC_NEUTRAL;
				}
				else	//(ballDirecX == DIREC_NEUTRAL)
				{
					ballDirecX = barDirecX;
				}
*/
//ẽoG[VlړiX2̈ړj
				if (ballDirecX == DIREC_LEFT)
				{
					if (barDirecX == DIREC_LEFT && 0 < ballX){ if (isVariety) ballXStep = 2; else ballX--; }
					else if (barDirecX == DIREC_RIGHT){ ballDirecX = DIREC_NEUTRAL;	ballXStep = 1; }
				}
				else if (ballDirecX == DIREC_RIGHT)
				{
					if (barDirecX == DIREC_RIGHT && ballX < FIELD_W - 1){ if (isVariety) ballXStep = 2; else ballX++; }
					else if (barDirecX == DIREC_LEFT){ ballDirecX = DIREC_NEUTRAL;	ballXStep = 1; }
				}
				else	//(ballDirecX == DIREC_NEUTRAL)
				{
					ballDirecX = barDirecX;
				}
				
			}
		}
		else if (BAR_Y <= ballY)		//o[̉֍s
		{
			fieldCount = 0;
			state = ST_GAMEOVER;
		}
		ballY += ballDirecY;
		
		//ubNƂ̓蔻Ɣ
		if (BLOCK_AREA_Y <= ballY && ballY < BLOCK_AREA_Y + BLOCK_AREA_H)
		{
			uint8_t		rr = ballY - BLOCK_AREA_Y;
			
			//̃{[ʒuzɃZbgiubN`撆Ƀ{[`悷邽߁j
			if (block[rr][ballX] == 0)
			{
				block[rr][ballX] = BALL_COLOR_NUM;
				ballPainted = 1;
			}
			else
			{
				block[rr][ballX]--;
				ballDirecY = -ballDirecY;	//cAƂ˂
				ballDirecX = -ballDirecX;
				
				//NA
				if (--restCount == 0)
				{
					fieldCount = 0;
					state = ST_CLEAR;
				}
			}
		}
		
	}	//end of while(1)
	
	return 0;
}

//ʂ`
void	draw()
{
	static	uint8_t		rr, boldCount;
	
	//fL21-262C
	if (lineCount < DRAW_LINE_TOP)
	{
		//`Jn
		if (lineCount == DRAW_LINE_TOP - 1)
		{
			rr = 0;
			boldCount = 0;
		}
	}
	//ubN̋Ԃ`
	else if (lineCount < cellToLine(BLOCK_AREA_Y))
	{
		uint16_t	ballLine = cellToLine(ballY);
		
		videoOut(SCRN_COLOR);
		
		//̋ԂɃ{[Ε`
		//vCtB[h[̏c̕`^C~O킹sAif()3Ԃɕ
		if (lineCount < ballLine)
		{
			delay_loop(5 + 3);	nop();
		}
		else if (lineCount < ballLine + CELL_H)
		{
			delay_loop(0 + 4);
			bbPos[ballX] = BALL_COLOR_NUM;
		}
		else	//(ballLine + CELL_H <= lineCount)
		{
			delay_loop(2 + 4);
		}
		aryPaint((uint16_t *)bbPos, FIELD_W);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	//vCtB[h[̏c
		bbPos[ballX] = 0;		//2sZbgňĕ`敝𒲐
		delay_loop(1);			//
		
		videoOut(SCRN_COLOR);
	}
	//ubN`
	else if (lineCount < cellToLine(BLOCK_AREA_Y + BLOCK_AREA_H))
	{
		videoOut(SCRN_COLOR);
		delay_loop(11);		//KvȂnop()ǉŔ
		
		aryPaint((uint16_t *)block[rr], (uint8_t)BLOCK_COLUMN);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	delay_loop(4);	//vCtB[h[̏c
		
		videoOut(SCRN_COLOR);
		
		if (++boldCount == CELL_H)
		{
			boldCount = 0;
			rr++;
		}
	}
	//ubNƃo[̊Ԃ̋Ԃ`
	else if (lineCount < cellToLine(BAR_Y))
	{
		uint16_t	ballLine = cellToLine(ballY);
		
		videoOut(SCRN_COLOR);
		
		//̋ԂɃ{[Ε`
		//vCtB[h[̏c̕`^C~O킹sAif()3Ԃɕ
		if (lineCount < ballLine)
		{
			delay_loop(5);
		}
		else if (lineCount < ballLine + CELL_H)
		{
			bbPos[ballX] = BALL_COLOR_NUM;
		}
		else	//(ballLine + CELL_H <= lineCount)
		{
			delay_loop(2);	nop();	nop();
		}
		aryPaint((uint16_t *)bbPos, FIELD_W);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	//vCtB[h[̏c
		bbPos[ballX] = 0;		//2sZbgňĕ`敝𒲐
		delay_loop(1);			//
		
		videoOut(SCRN_COLOR);
	}
	//o[`
	else if (lineCount < cellToLine(BAR_Y) + CELL_H)
	{
		videoOut(SCRN_COLOR);
		delay_loop(10);	nop();	nop();	//KvȂnop()ǉŔ
		
		aryPaint((uint16_t *)bbPos, barX);	//o[̈ʒu܂ł̋󔒂`i20łokj
		videoOut(BAR_COLOR);	delay_loop(12 * BAR_W);		//o[`
		//vCtB[hE[̏c͏ȗi`̃^C~O킹̂ʓ|j
		
		videoOut(SCRN_COLOR);
	}
	else
	{
		videoOut(SCRN_COLOR);
	}
}

//vCJn̏
void	init(int8_t *barDirecX, int8_t *ballDirecX, int8_t *ballDirecY, uint8_t *restCount)
{
	uint8_t		rr, cc;
	
	ballX = FIELD_W / 2;
	ballY = BAR_Y - 1;
	*barDirecX = DIREC_NEUTRAL;
	*ballDirecX = DIREC_NEUTRAL;
	*ballDirecY = DIREC_UP;
	
	//ubN̏l
	for (rr = 0; rr < BLOCK_ROW; rr++)
		for (cc = 0; cc < BLOCK_COLUMN; cc++)
			block[rr][cc] = 2;
	*restCount = BLOCK_ROW * BLOCK_COLUMN * 2;
	
	bbPos[ballX] = BALL_COLOR_NUM;
}

//AiORp[^pA/DRo[^
uint8_t	acadc(uint8_t val)
{
	static	uint8_t		adcState = ADCST_DISCHGWAIT, dischgWait = 1;
	
	switch (adcState)
	{
	case ADCST_CHARGING:
		if (ACSR & _BV(ACO))
		{
			//TCNT1̉8bit͎̂ĂiAiO͂ɑΉl̕ω8bitɎ܂悤ȃŴŁj
			//TCNT1̗hꕝ傫̂ŕiAl傫ƃ}X̕ςڂŃo[݂̔Blƕ̌ʂȂj
			uint16_t	t = (TCNT1 >> 8), v = val;	//t,vƂ8bitvZߒ16bit𒴂
			val = (uint8_t)((v * 5 + t) / 6);		//vZʂ͕K8bitɎ܂
			adcState = ADCST_CHARGESTOP;
		}
		break;
		
	case ADCST_CHARGESTOP:
#if _ADC_DEBUG
		{
			int8_t	i;
			uint8_t	bits = val;
			for (i = 7; 0 <= i; i--, bits >>= 1)
				block[0][i] = (bits & 1);
		}		
#endif
		//RfTd
		//dԂ͏\Ɏ邱ƁidischgWait=0xF0Ȃ0x80j
		PORTB &= ~0b00000100;
		dischgWait = 0xF0;
		adcState = ADCST_DISCHGWAIT;
		break;
		
	default:	//case ADCST_DISCHGWAIT:
		if (--dischgWait == 0)
		{
			//RfT[d
			TCNT1 = 0;
			PORTB |= 0b00000100;
			adcState = ADCST_CHARGING;
		}
		break;
	}
	
	return val;
}

//A/DRo[^̕ϊlo[̈ʒu擾
//EZƕ`悪኱̂ŎgȂ悤ɂ
//Eval͕ɂȂȂAuint8_tŒ`ƃvOTCY20byteĂ܂
uint8_t	getAnalogBarX(uint8_t adcVal)
{
	uint8_t	ret = 0;
	int8_t	val;
	
	if (adcVal < ACADC_MIN) adcVal = ACADC_MIN;
	if (ACADC_MAX < adcVal) adcVal = ACADC_MAX;
//	return (adcVal - ACADC_MIN) / ACADC_STEP;
	
	val = (adcVal - ACADC_MIN);
	while (ACADC_STEP <= val){ val -= ACADC_STEP;	ret++; }
	return ret;
}
